vec3 hsv2rgb(vec3 c)
{
    const vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

void main()
{
    vec3 col = vec3(u_section * ((u_time * u_speed) + v_tex_coord.x), u_saturation, u_brightness);
    vec4 texColor = texture2D(u_texture, v_tex_coord);
    vec4 finalCol = mix(texColor, vec4(hsv2rgb(col), texColor.a), u_mix);
    
    gl_FragColor = finalCol * texColor.a * v_color_mix.a;
}
