vec2 normalizedFromAtlasCoord(vec2 coord, vec2 rectOrigin, vec2 rectSize) {
    coord -= rectOrigin;
    coord *= 1.0 / rectSize;
    return coord;
}

vec2 atlasFromNormalizedCoord(vec2 coord, vec2 rectOrigin, vec2 rectSize) {
    coord *= rectSize;
    coord += rectOrigin;
    return coord;
}

vec2 nearestNeighbor(vec2 loc, vec2 size) {
    return (floor(loc * size) + 0.5) / size;
}

void main()
{
    vec2 texCoord = normalizedFromAtlasCoord(v_tex_coord, a_texture_rect_origin, a_texture_rect_size);
    
    texCoord += a_texture_offset;
    texCoord = mod(texCoord, a_repeat_factor) / a_repeat_factor;
    texCoord = nearestNeighbor(texCoord, a_texture_size);
    
    texCoord = atlasFromNormalizedCoord(texCoord, a_texture_rect_origin, a_texture_rect_size);
    
    vec4 texColor = texture2D(u_texture, texCoord);
    gl_FragColor = texColor * v_color_mix.a;
}
