// https://www.shadertoy.com/view/ldXXRj
vec4 contrast(vec4 colors, float contrast)
{
    colors.rgb /= colors.a;
    colors.rgb = ((colors.rgb - 0.5) * max(contrast + 1.0, 0.0)) + 0.5;
    colors.rgb *= colors.a;
    return colors;
}

vec4 brightness(vec4 colors, float brightness)
{
    colors.rgb /= colors.a;
    colors.rgb += brightness;
    colors.rgb *= colors.a;
    return colors;
}

void main()
{
    vec4 colors = texture2D(u_texture, v_tex_coord);
    float brightnessRatio = mix(0.2, 0.3, sin(u_time));
    //gl_FragColor = brightness(contrast(colors, brightnessRatio), brightnessRatio);
    gl_FragColor = brightness(colors, brightnessRatio) * v_color_mix.a;
}
