vec2 nearestNeighbor(vec2 loc, vec2 size) {
    return (floor(loc * size) + 0.5) / size;
}

void main() {
    vec2 nearestTexCoord = nearestNeighbor(v_tex_coord, a_sprite_size);
    vec4 texColor = texture2D(u_texture, nearestTexCoord);
    
    // force alpha to 1.0 (fully opaque)
    texColor.a = 1.0;

    // Apply color mix and set fragment color
    gl_FragColor = texColor * v_color_mix.a;
}
